<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: FreeRTOSTimer Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classFreeRTOSTimer-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">FreeRTOSTimer Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Wrapper around the FreeRTOS timer functions.  
 <a href="classFreeRTOSTimer.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="FreeRTOSTimer_8h_source.html">FreeRTOSTimer.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a71b533a7326cf6f9b095ef6d2277bb1d"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOSTimer.html#a71b533a7326cf6f9b095ef6d2277bb1d">FreeRTOSTimer</a> (char *name, TickType_t period, UBaseType_t reload, void *data, void(*callback)(<a class="el" href="classFreeRTOSTimer.html">FreeRTOSTimer</a> *pTimer))</td></tr>
<tr class="memdesc:a71b533a7326cf6f9b095ef6d2277bb1d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a timer.  <a href="#a71b533a7326cf6f9b095ef6d2277bb1d">More...</a><br /></td></tr>
<tr class="separator:a71b533a7326cf6f9b095ef6d2277bb1d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa8a047ff6418d0d0d62716f47fd863c5"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOSTimer.html#aa8a047ff6418d0d0d62716f47fd863c5">~FreeRTOSTimer</a> ()</td></tr>
<tr class="memdesc:aa8a047ff6418d0d0d62716f47fd863c5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy a class instance.  <a href="#aa8a047ff6418d0d0d62716f47fd863c5">More...</a><br /></td></tr>
<tr class="separator:aa8a047ff6418d0d0d62716f47fd863c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2032df1fe519879731656090709abfad"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOSTimer.html#a2032df1fe519879731656090709abfad">changePeriod</a> (TickType_t newPeriod, TickType_t blockTime=portMAX_DELAY)</td></tr>
<tr class="memdesc:a2032df1fe519879731656090709abfad"><td class="mdescLeft">&#160;</td><td class="mdescRight">Change the period of the timer.  <a href="#a2032df1fe519879731656090709abfad">More...</a><br /></td></tr>
<tr class="separator:a2032df1fe519879731656090709abfad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a162a7a248cef2303e6b96048056ef322"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOSTimer.html#a162a7a248cef2303e6b96048056ef322">getData</a> ()</td></tr>
<tr class="memdesc:a162a7a248cef2303e6b96048056ef322"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the user supplied data associated with the timer.  <a href="#a162a7a248cef2303e6b96048056ef322">More...</a><br /></td></tr>
<tr class="separator:a162a7a248cef2303e6b96048056ef322"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9ab13f95f2bcb12a65fee1775f9c40b8"><td class="memItemLeft" align="right" valign="top">const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOSTimer.html#a9ab13f95f2bcb12a65fee1775f9c40b8">getName</a> ()</td></tr>
<tr class="memdesc:a9ab13f95f2bcb12a65fee1775f9c40b8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the name of the timer.  <a href="#a9ab13f95f2bcb12a65fee1775f9c40b8">More...</a><br /></td></tr>
<tr class="separator:a9ab13f95f2bcb12a65fee1775f9c40b8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a423965d8980aae6a1877b338a2d83d55"><td class="memItemLeft" align="right" valign="top">TickType_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOSTimer.html#a423965d8980aae6a1877b338a2d83d55">getPeriod</a> ()</td></tr>
<tr class="memdesc:a423965d8980aae6a1877b338a2d83d55"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the period of the timer.  <a href="#a423965d8980aae6a1877b338a2d83d55">More...</a><br /></td></tr>
<tr class="separator:a423965d8980aae6a1877b338a2d83d55"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1f243c23d6d6edece568fe0e9de0209"><td class="memItemLeft" align="right" valign="top"><a id="ae1f243c23d6d6edece568fe0e9de0209"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOSTimer.html#ae1f243c23d6d6edece568fe0e9de0209">reset</a> (TickType_t blockTime=portMAX_DELAY)</td></tr>
<tr class="memdesc:ae1f243c23d6d6edece568fe0e9de0209"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset the timer to the period and start it ticking. <br /></td></tr>
<tr class="separator:ae1f243c23d6d6edece568fe0e9de0209"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4cad6643b084ed3813a424fa60547742"><td class="memItemLeft" align="right" valign="top"><a id="a4cad6643b084ed3813a424fa60547742"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOSTimer.html#a4cad6643b084ed3813a424fa60547742">start</a> (TickType_t blockTime=portMAX_DELAY)</td></tr>
<tr class="memdesc:a4cad6643b084ed3813a424fa60547742"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start the timer ticking. <br /></td></tr>
<tr class="separator:a4cad6643b084ed3813a424fa60547742"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adfa6641c22dba498dcd44744294d072d"><td class="memItemLeft" align="right" valign="top"><a id="adfa6641c22dba498dcd44744294d072d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOSTimer.html#adfa6641c22dba498dcd44744294d072d">stop</a> (TickType_t blockTime=portMAX_DELAY)</td></tr>
<tr class="memdesc:adfa6641c22dba498dcd44744294d072d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Stop the timer from ticking. <br /></td></tr>
<tr class="separator:adfa6641c22dba498dcd44744294d072d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Wrapper around the FreeRTOS timer functions. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a71b533a7326cf6f9b095ef6d2277bb1d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a71b533a7326cf6f9b095ef6d2277bb1d">&#9670;&nbsp;</a></span>FreeRTOSTimer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">FreeRTOSTimer::FreeRTOSTimer </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TickType_t&#160;</td>
          <td class="paramname"><em>period</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">UBaseType_t&#160;</td>
          <td class="paramname"><em>reload</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(<a class="el" href="classFreeRTOSTimer.html">FreeRTOSTimer</a> *pTimer)&#160;</td>
          <td class="paramname"><em>callback</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct a timer. </p>
<p>We construct a timer that will fire after the given period has elapsed. The period is measured in ticks. When the timer fires, the callback function is invoked within the scope/context of the timer demon thread. As such it must <b>not</b> block. Once the timer has fired, if the reload flag is true, then the timer will be automatically restarted.</p>
<p>Note that the timer does <em>not</em> start immediately. It starts ticking after the <a class="el" href="classFreeRTOSTimer.html#a4cad6643b084ed3813a424fa60547742" title="Start the timer ticking.">start()</a> method has been called.</p>
<p>The signature of the callback function is:</p>
<div class="fragment"><div class="line"><span class="keywordtype">void</span> callback(<a class="code" href="classFreeRTOSTimer.html">FreeRTOSTimer</a> *pTimer) {</div><div class="line"> <span class="comment">// Callback code here ...</span></div><div class="line">}</div></div><!-- fragment --><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">name</td><td>The name of the timer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">period</td><td>The period of the timer in ticks. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">reload</td><td>True if the timer is to restart once fired. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>Data to be passed to the callback. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">callback</td><td>Callback function to be fired when the timer expires. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aa8a047ff6418d0d0d62716f47fd863c5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa8a047ff6418d0d0d62716f47fd863c5">&#9670;&nbsp;</a></span>~FreeRTOSTimer()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">FreeRTOSTimer::~FreeRTOSTimer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Destroy a class instance. </p>
<p>The timer is deleted. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a2032df1fe519879731656090709abfad"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2032df1fe519879731656090709abfad">&#9670;&nbsp;</a></span>changePeriod()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void FreeRTOSTimer::changePeriod </td>
          <td>(</td>
          <td class="paramtype">TickType_t&#160;</td>
          <td class="paramname"><em>newPeriod</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TickType_t&#160;</td>
          <td class="paramname"><em>blockTime</em> = <code>portMAX_DELAY</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Change the period of the timer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">newPeriod</td><td>The new period of the timer in ticks. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a162a7a248cef2303e6b96048056ef322"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a162a7a248cef2303e6b96048056ef322">&#9670;&nbsp;</a></span>getData()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void * FreeRTOSTimer::getData </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the user supplied data associated with the timer. </p>
<dl class="section return"><dt>Returns</dt><dd>The user supplied data associated with the timer. </dd></dl>

</div>
</div>
<a id="a9ab13f95f2bcb12a65fee1775f9c40b8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9ab13f95f2bcb12a65fee1775f9c40b8">&#9670;&nbsp;</a></span>getName()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const char * FreeRTOSTimer::getName </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the name of the timer. </p>
<dl class="section return"><dt>Returns</dt><dd>The name of the timer. </dd></dl>

</div>
</div>
<a id="a423965d8980aae6a1877b338a2d83d55"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a423965d8980aae6a1877b338a2d83d55">&#9670;&nbsp;</a></span>getPeriod()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">TickType_t FreeRTOSTimer::getPeriod </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Return the period of the timer. </p>
<dl class="section return"><dt>Returns</dt><dd>The period of the timer. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="FreeRTOSTimer_8h_source.html">FreeRTOSTimer.h</a></li>
<li>FreeRTOSTimer.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
